diff --git a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/description/CategoricalData.java b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/description/CategoricalData.java
index 26bd124921..61a2ac07ef 100644
--- a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/description/CategoricalData.java
+++ b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/description/CategoricalData.java
@@ -52,13 +52,12 @@ import eu.etaxonomy.cdm.validation.Level2;
  * the SDD schema.
  *
  * @author m.doering
- * @version 1.0
  * @created 08-Nov-2007 13:06:15
  */
 @XmlAccessorType(XmlAccessType.FIELD)
 @XmlType(name = "CategoricalData", propOrder = {
     "orderRelevant",
-    "states"
+    "stateData"
 })
 @XmlRootElement(name = "CategoricalData")
 @Entity
@@ -79,7 +78,7 @@ public class CategoricalData extends DescriptionElementBase implements Cloneable
     @Cascade({ CascadeType.SAVE_UPDATE, CascadeType.MERGE, CascadeType.DELETE,CascadeType.DELETE_ORPHAN })
     @IndexedEmbedded(depth = 3)
     @NotEmpty(groups = Level2.class)
-    private List<StateData> states = new ArrayList<StateData>();
+    private List<StateData> stateData = new ArrayList<StateData>();
 
 //****************************** FACTORY METHOD *******************************/
 
@@ -112,7 +111,7 @@ public class CategoricalData extends DescriptionElementBase implements Cloneable
     protected CategoricalData(List<State> states, Feature feature) {
         super(feature);
         for (State state : states){
-        	addState(state);
+        	addStateData(state);
         }
         
     }
@@ -124,48 +123,48 @@ public class CategoricalData extends DescriptionElementBase implements Cloneable
      * corresponding to <i>this</i> categorical data.
      */
 
-    public List<StateData> getStates(){
-        return this.states;
+    public List<StateData> getStateData(){
+        return this.stateData;
     }
 
     protected void setStates(List<StateData> stateData){
-        this.states = stateData;
+        this.stateData = stateData;
     }
 
 
     /**
-     * Adds a {@link State state} to the list of {@link #getStates() states}
+     * Adds a {@link State state} to the list of {@link #getStateData() states}
      * describing the {@link Feature feature} corresponding to <i>this</i> categorical data.
      *
      * @param state	the state to be added to <i>this</i> categorical data
-     * @see    	   	#getStates()
+     * @see    	   	#getStateData()
      */
-    public void addState(StateData state){
-        this.states.add(state);
+    public void addStateData(StateData stateData){
+        this.stateData.add(stateData);
     }
 
     /**
      * Convenience method which creates a state data from a given state with no modifiers
      * and adds it to the list of state data
-     * @see #addState(StateData)
+     * @see #addStateData(StateData)
      * @param state
      */
-    public void addState(State state){
+    public void addStateData(State state){
         StateData stateData = StateData.NewInstance(state);
-        this.states.add(stateData);
+        this.stateData.add(stateData);
     }
 
 
     /**
-     * Removes one element from the set of {@link #getStates() states}
+     * Removes one element from the set of {@link #getStateData() states}
      * describing the {@link Feature feature} corresponding to <i>this</i> categorical data.
      *
      * @param  state	the state which should be removed
-     * @see     		#getStates()
-     * @see     		#addState(State)
+     * @see     		#getStateData()
+     * @see     		#addStateData(State)
      */
-    public void removeState(StateData state){
-        this.states.remove(state);
+    public void removeStateData(StateData stateData){
+        this.stateData.remove(stateData);
     }
 
     //rename to isStateSequenceIntentional ??
@@ -196,7 +195,7 @@ public class CategoricalData extends DescriptionElementBase implements Cloneable
     @Transient
     public List<State> getStatesOnly(){
         List<State> result = new ArrayList<State>();
-        for (StateData stateData : getStates()){
+        for (StateData stateData : getStateData()){
             State state = stateData.getState();
             result.add(state);
         }
@@ -209,13 +208,13 @@ public class CategoricalData extends DescriptionElementBase implements Cloneable
      * @return
      */
     @Transient
-    public List<StateData> setStatesOnly(List<State> states){
-        this.states.clear();
+    public List<StateData> setStateDataOnly(List<State> states){
+        this.stateData.clear();
         for (State state : states){
             StateData stateDate = StateData.NewInstance(state);
-            this.states.add(stateDate);
+            this.stateData.add(stateDate);
         }
-        return this.states;
+        return this.stateData;
     }
 
 
@@ -236,11 +235,11 @@ public class CategoricalData extends DescriptionElementBase implements Cloneable
             CategoricalData result = (CategoricalData)super.clone();
 
             //states
-            result.states = new ArrayList<StateData>();
-            for (StateData stateData : getStates()){
+            result.stateData = new ArrayList<StateData>();
+            for (StateData stateData : getStateData()){
                 //TODO do we need to clone here?
                 //StateData newState = (StateData)stateData.clone();
-                result.states.add(stateData);
+                result.stateData.add(stateData);
             }
 
             return result;
diff --git a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/description/DescriptionBase.java b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/description/DescriptionBase.java
index 03cf78f23b..a6f9809ca7 100644
--- a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/description/DescriptionBase.java
+++ b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/description/DescriptionBase.java
@@ -12,12 +12,15 @@ package eu.etaxonomy.cdm.model.description;
 import java.util.HashSet;
 import java.util.Set;
 
+import javax.persistence.Column;
 import javax.persistence.Entity;
 import javax.persistence.FetchType;
 import javax.persistence.Inheritance;
 import javax.persistence.InheritanceType;
+import javax.persistence.JoinColumn;
 import javax.persistence.JoinTable;
 import javax.persistence.ManyToMany;
+import javax.persistence.ManyToOne;
 import javax.persistence.OneToMany;
 import javax.persistence.Transient;
 import javax.xml.bind.annotation.XmlAccessType;
@@ -36,15 +39,17 @@ import org.hibernate.envers.Audited;
 import org.hibernate.search.annotations.ClassBridge;
 import org.hibernate.search.annotations.ClassBridges;
 import org.hibernate.search.annotations.ContainedIn;
-import org.hibernate.search.annotations.Field;
+import org.hibernate.search.annotations.IndexedEmbedded;
 
 import eu.etaxonomy.cdm.hibernate.search.DescriptionBaseClassBridge;
 import eu.etaxonomy.cdm.hibernate.search.GroupByTaxonClassBridge;
 import eu.etaxonomy.cdm.model.common.IdentifiableEntity;
 import eu.etaxonomy.cdm.model.name.NameRelationship;
+import eu.etaxonomy.cdm.model.name.TaxonNameBase;
 import eu.etaxonomy.cdm.model.name.TypeDesignationBase;
 import eu.etaxonomy.cdm.model.occurrence.SpecimenOrObservationBase;
 import eu.etaxonomy.cdm.model.reference.Reference;
+import eu.etaxonomy.cdm.model.taxon.Taxon;
 import eu.etaxonomy.cdm.strategy.cache.common.IIdentifiableEntityCacheStrategy;
 
 /**
@@ -65,9 +70,8 @@ import eu.etaxonomy.cdm.strategy.cache.common.IIdentifiableEntityCacheStrategy;
 
 @XmlAccessorType(XmlAccessType.FIELD)
 @XmlType(name = "DescriptionBase", propOrder = {
-    "describedSpecimenOrObservations",
+    "describedSpecimenOrObservation",
     "descriptionSources",
-    "descriptiveSystem",
     "workingSets",
     "descriptionElements",
     "imageGallery"
@@ -83,14 +87,25 @@ public abstract class DescriptionBase<S extends IIdentifiableEntityCacheStrategy
     private static final long serialVersionUID = 5504218413819040193L;
     private static final Logger logger = Logger.getLogger(DescriptionBase.class);
 
-    @XmlElementWrapper(name = "DescribedSpecimenOrObservations")
-    @XmlElement(name = "DescribedSpecimenOrObservation")
+//    @XmlElementWrapper(name = "DescribedSpecimenOrObservations")
+//    @XmlElement(name = "DescribedSpecimenOrObservation")
+//    @XmlIDREF
+//    @XmlSchemaType(name="IDREF")
+//    @ManyToMany(fetch = FetchType.LAZY)
+//    @Cascade(CascadeType.SAVE_UPDATE)
+//    private Set<SpecimenOrObservationBase> describedSpecimenOrObservations = new HashSet<SpecimenOrObservationBase>();
+
+    @XmlElement( name = "DescribedSpecimenOrObservation")
+    @ManyToOne(fetch = FetchType.LAZY)
     @XmlIDREF
     @XmlSchemaType(name="IDREF")
-    @ManyToMany(fetch = FetchType.LAZY)
     @Cascade(CascadeType.SAVE_UPDATE)
-    private Set<SpecimenOrObservationBase> describedSpecimenOrObservations = new HashSet<SpecimenOrObservationBase>();
-
+    @JoinColumn(name="specimen_id")
+    @IndexedEmbedded
+    //TODO maybe move down to specific classes SpecimenDescription (with Cascade.Delete) and TaxonDescription (without Cascade)
+    private SpecimenOrObservationBase describedSpecimenOrObservation;
+    
+    
     @XmlElementWrapper(name = "DescriptionSources")
     @XmlElement(name = "DescriptionSource")
     @XmlIDREF
@@ -98,17 +113,6 @@ public abstract class DescriptionBase<S extends IIdentifiableEntityCacheStrategy
     @ManyToMany(fetch = FetchType.LAZY)  //FIXME what is the difference between this and IdentifiableEntity.sources
     private Set<Reference> descriptionSources = new HashSet<Reference>();
 
-    @XmlElementWrapper(name = "DescriptiveSystem")
-    @XmlElement(name = "Feature")
-    @XmlIDREF
-    @XmlSchemaType(name="IDREF")
-    @ManyToMany(fetch = FetchType.LAZY)  //FIXME
-    //@Cascade( { CascadeType.SAVE_UPDATE, CascadeType.MERGE })
-    @JoinTable(name = "DescriptionBase_Feature")
-    @Deprecated //will probably be removed in future versions due to #2240
-    //fortunately never worked well due to missing cascade #1846
-    private Set<Feature> descriptiveSystem = new HashSet<Feature>();
-
     @XmlElementWrapper(name = "WorkingSets")
     @XmlElement(name = "WorkingSet")
     @XmlIDREF
@@ -135,60 +139,37 @@ public abstract class DescriptionBase<S extends IIdentifiableEntityCacheStrategy
     @XmlElement(name = "ImageGallery")
     private boolean imageGallery;
 
-
+    
     /**
-     * Returns the set of {@link SpecimenOrObservationBase specimens or observations} involved in
+     * Returns a {@link SpecimenOrObservationBase specimen or observation} involved in
      * <i>this</i> description as a whole. {@link TaxonDescription Taxon descriptions} are also often based
      * on concrete specimens or observations. For {@link TaxonNameDescription taxon name descriptions}
-     * this set should be empty.
-     *
-     * @see    #addDescribedSpecimenOrObservations(SpecimenOrObservationBase)
-     * @see    #removeDescribedSpecimenOrObservations(SpecimenOrObservationBase)
+     * this attribute should be empty.
+     * To handle sets of specimen or observations one may first group them by a derivation event of type
+     * "Grouping" and then use the grouped unit here.
+     * @return
      */
-    public Set<SpecimenOrObservationBase> getDescribedSpecimenOrObservations() {
-        return describedSpecimenOrObservations;
-    }
-
-    /**
-     * Adds an existing {@link SpecimenOrObservationBase specimen or observation} to the set of
-     * {@link #getDescribedSpecimenOrObservations() specimens or observations} described in <i>this</i>
-     * description or which <i>this</i> description is based on.<BR>
-     * Due to bidirectionality if <i>this</i> description is a {@link SpecimenDescription specimen description},
-     * <i>this</i> description will also be added to the set of specimen
-     * descriptions corresponding to the given additional specimen or observation.
-     *
-     * @param describedSpecimenOrObservation	the specimen or observation to be added to <i>this</i> description
-     * @see    	   								#getDescribedSpecimenOrObservations()
-     * @see    	   								SpecimenOrObservationBase#addDescription(DescriptionBase)
-     */
-    public void addDescribedSpecimenOrObservation(SpecimenOrObservationBase describedSpecimenOrObservation) {
-        logger.debug("addDescribedSpecimenOrObservations");
-        this.describedSpecimenOrObservations.add(describedSpecimenOrObservation);
-        if (! describedSpecimenOrObservation.getDescriptions().contains(this)){
-            describedSpecimenOrObservation.addDescription(this);
-        }
-    }
-
-    /**
-     * Removes one element from the set of {@link #getDescribedSpecimenOrObservations() specimens or observations} involved
-     * in <i>this</i> description.<BR>
-     * Due to bidirectionality if <i>this</i> description is a {@link SpecimenDescription specimen description},
-     * <i>this</i> description will also be removed from the set of specimen
-     * descriptions corresponding to the given specimen or observation.
-     *
-     * @param  describedSpecimenOrObservation   the specimen or observation which should be removed
-     * @see     		  						#getDescribedSpecimenOrObservations()
-     * @see     		  						#addDescribedSpecimenOrObservations(SpecimenOrObservationBase)
-     * @see     		  						SpecimenOrObservationBase#removeDescription(DescriptionBase)
-     */
-    public void removeDescribedSpecimenOrObservation(SpecimenOrObservationBase describedSpecimenOrObservation) {
-        this.describedSpecimenOrObservations.remove(describedSpecimenOrObservation);
-        if (describedSpecimenOrObservation.getDescriptions().contains(this)){
-            describedSpecimenOrObservation.removeDescription(this);
-        }
-    }
-
-    /**
+    public SpecimenOrObservationBase getDescribedSpecimenOrObservation() {
+		return describedSpecimenOrObservation;
+	}
+
+
+	/**
+	 * @see #getDescribedSpecimenOrObservation()
+	 * @param describedSpecimenOrObservation
+	 */
+	//TODO bidirectional method should maybe removed as a description should belong to its specimen or taxon
+    public void setDescribedSpecimenOrObservation(SpecimenOrObservationBase describedSpecimenOrObservation) {
+		if (describedSpecimenOrObservation == null ){
+			this.describedSpecimenOrObservation.removeDescription(this);
+		}else if (! describedSpecimenOrObservation.getDescriptions().contains(this)){
+			describedSpecimenOrObservation.addDescription(this);
+		}
+		this.describedSpecimenOrObservation = describedSpecimenOrObservation;
+	}
+
+
+	/**
      * Returns the set of {@link Reference references} used as sources for <i>this</i> description as a
      * whole. More than one source can be used for a general description without
      * assigning for each data element of the description one of those sources.
@@ -227,49 +208,6 @@ public abstract class DescriptionBase<S extends IIdentifiableEntityCacheStrategy
         this.descriptionSources.remove(descriptionSource);
     }
 
-    /**
-     * Returns the set of {@link Feature feature} used as
-     * features/characters/descriptors for <i>this</i> description.
-     *
-     * @see    #addFeature(Feature)
-     * @see    #removeFeature(Feature)
-     */
-    public Set<Feature> getDescriptiveSystem() {
-        return this.descriptiveSystem;
-    }
-
-    /**
-     * @see    #getDescriptiveSystem()
-     * @see    #addDescriptiveSystem(Feature)
-     */
-    public void setDescriptiveSystem(Set<Feature> descriptiveSystem) {
-        this.descriptiveSystem = descriptiveSystem;
-    }
-
-    /**
-     * Adds an existing {@link Feature feature} to the set of
-     * {@link #getDescriptiveSystem() descriptiveSystem} used as features for
-     * <i>this</i> description.
-     *
-     * @param feature	the feature to be added to the descriptive system
-     * @see     #getDescriptiveSystem()
-     */
-    public void addFeature(Feature feature) {
-        this.descriptiveSystem.add(feature);
-    }
-
-    /**
-     * Removes one element from the set of {@link #getDescriptiveSystem() features} used as
-     * features for <i>this</i> description.
-     *
-     * @param  feature	the feature which should be deleted
-     * @see     #getDescriptiveSystem()
-     * @see     addFeature(Feature)
-     */
-    public void removeFeature(Feature feature) {
-        this.descriptiveSystem.remove(feature);
-    }
-
     /**
      * Returns the set of {@link DescriptionElementBase elementary description data} which constitute
      * <i>this</i> description as a whole.
@@ -400,12 +338,6 @@ public abstract class DescriptionBase<S extends IIdentifiableEntityCacheStrategy
         try{
             result = (DescriptionBase)super.clone();
 
-            //descriptive system
-            result.descriptiveSystem = new HashSet<Feature>();
-            for (Feature feature : getDescriptiveSystem()){
-                result.descriptiveSystem.add(feature);
-            }
-
             //working set
             result.workingSets = new HashSet<WorkingSet>();
             for (WorkingSet workingSet : getWorkingSets()){
@@ -425,12 +357,6 @@ public abstract class DescriptionBase<S extends IIdentifiableEntityCacheStrategy
                 result.addElement(newElement);
             }
 
-            //specimen or observations
-            result.describedSpecimenOrObservations = new HashSet<SpecimenOrObservationBase>();
-            for (SpecimenOrObservationBase specimenOrObservation : getDescribedSpecimenOrObservations()){
-                specimenOrObservation.addDescription(result);
-            }
-
             //no changes to: imageGallery
             return result;
         } catch (CloneNotSupportedException e) {
diff --git a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/description/DescriptionElementBase.java b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/description/DescriptionElementBase.java
index ec14881ca2..88bd5059e4 100644
--- a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/description/DescriptionElementBase.java
+++ b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/description/DescriptionElementBase.java
@@ -44,13 +44,16 @@ import org.hibernate.search.annotations.IndexedEmbedded;
 
 import eu.etaxonomy.cdm.jaxb.MultilanguageTextAdapter;
 import eu.etaxonomy.cdm.model.common.AnnotatableEntity;
-import eu.etaxonomy.cdm.model.common.DescriptionElementSource;
+import eu.etaxonomy.cdm.model.common.DefinedTerm;
 import eu.etaxonomy.cdm.model.common.IMultiLanguageTextHolder;
+import eu.etaxonomy.cdm.model.common.IOriginalSource;
 import eu.etaxonomy.cdm.model.common.ISourceable;
 import eu.etaxonomy.cdm.model.common.Language;
 import eu.etaxonomy.cdm.model.common.LanguageString;
 import eu.etaxonomy.cdm.model.common.MultilanguageText;
+import eu.etaxonomy.cdm.model.common.OriginalSourceType;
 import eu.etaxonomy.cdm.model.common.TermVocabulary;
+import eu.etaxonomy.cdm.model.common.TimePeriod;
 import eu.etaxonomy.cdm.model.media.Media;
 import eu.etaxonomy.cdm.model.name.TaxonNameBase;
 import eu.etaxonomy.cdm.model.occurrence.SpecimenOrObservationBase;
@@ -74,17 +77,17 @@ import eu.etaxonomy.cdm.strategy.merge.MergeMode;
  * </ul>
  *
  * @author m.doering
- * @version 1.0
  * @created 08-Nov-2007 13:06:24
  */
 @XmlAccessorType(XmlAccessType.FIELD)
 @XmlType(name = "DescriptionElementBase", propOrder = {
-        "feature",
-        "modifiers",
-        "modifyingText",
-        "media",
-        "inDescription",
-        "sources"
+    "feature",
+    "inDescription",
+    "timeperiod",
+    "modifiers",
+    "modifyingText",
+    "media",
+    "sources"
 })
 @Entity
 @Audited
@@ -111,7 +114,7 @@ public abstract class DescriptionElementBase extends AnnotatableEntity implement
     @ManyToMany(fetch = FetchType.LAZY)
     @JoinTable(name="DescriptionElementBase_Modifier")
     @IndexedEmbedded(depth=1)
-    private Set<Modifier> modifiers = new HashSet<Modifier>();
+    private Set<DefinedTerm> modifiers = new HashSet<DefinedTerm>();
 
     @XmlElement(name = "ModifyingText")
     @XmlJavaTypeAdapter(MultilanguageTextAdapter.class)
@@ -138,6 +141,9 @@ public abstract class DescriptionElementBase extends AnnotatableEntity implement
     @Cascade(CascadeType.SAVE_UPDATE)
     @IndexedEmbedded
     private DescriptionBase inDescription;
+    
+	@XmlElement(name = "TimePeriod")
+    private TimePeriod timeperiod = TimePeriod.NewInstance();;
 
     @XmlElementWrapper(name = "Sources")
     @XmlElement(name = "DescriptionElementSource")
@@ -234,10 +240,28 @@ public abstract class DescriptionElementBase extends AnnotatableEntity implement
     }
 
     /**
+	 * The point in time, the time period or the season for which this description element 
+	 * is valid. A season may be expressed by not filling the year part(s) of the time period. 
+	 */
+	public TimePeriod getTimeperiod() {
+		return timeperiod;
+	}
+
+	/**
+	 * @see #getTimeperiod()
+	 */
+	public void setTimeperiod(TimePeriod timeperiod) {
+		if (timeperiod == null){
+			timeperiod = TimePeriod.NewInstance();
+		}
+		this.timeperiod = timeperiod;
+	}
+
+	/**
      * Returns the set of {@link Modifier modifiers} used to qualify the validity of
      * <i>this</i> description element. This is only metainformation.
      */
-    public Set<Modifier> getModifiers(){
+    public Set<DefinedTerm> getModifiers(){
         return this.modifiers;
     }
 
@@ -248,7 +272,7 @@ public abstract class DescriptionElementBase extends AnnotatableEntity implement
      * @param modifier	the modifier to be added to <i>this</i> description element
      * @see    	   		#getModifiers()
      */
-    public void addModifier(Modifier modifier){
+    public void addModifier(DefinedTerm modifier){
         this.modifiers.add(modifier);
     }
     /**
@@ -259,7 +283,7 @@ public abstract class DescriptionElementBase extends AnnotatableEntity implement
      * @see     		#getModifiers()
      * @see     		#addModifier(Modifier)
      */
-    public void removeModifier(Modifier modifier){
+    public void removeModifier(DefinedTerm modifier){
         this.modifiers.remove(modifier);
     }
 
@@ -376,19 +400,43 @@ public abstract class DescriptionElementBase extends AnnotatableEntity implement
     }
 
     /* (non-Javadoc)
-     * @see eu.etaxonomy.cdm.model.common.ISourceable#addSource(java.lang.String, java.lang.String, eu.etaxonomy.cdm.model.reference.Reference, java.lang.String)
+     * @see eu.etaxonomy.cdm.model.common.ISourceable#addSource(eu.etaxonomy.cdm.model.common.OriginalSourceType, java.lang.String, java.lang.String, eu.etaxonomy.cdm.model.reference.Reference, java.lang.String)
      */
-    public DescriptionElementSource addSource(String id, String idNamespace, Reference citation, String microCitation) {
+    public DescriptionElementSource addSource(OriginalSourceType type, String id, String idNamespace, Reference citation, String microCitation) {
         if (id == null && idNamespace == null && citation == null && microCitation == null){
             return null;
         }
-        DescriptionElementSource source = DescriptionElementSource.NewInstance(id, idNamespace, citation, microCitation);
+        DescriptionElementSource source = DescriptionElementSource.NewInstance(type, id, idNamespace, citation, microCitation);
+        addSource(source);
+        return source;
+    }
+    
+    
+    /* (non-Javadoc)
+     * @see eu.etaxonomy.cdm.model.common.ISourceable#addImportSource(java.lang.String, java.lang.String, eu.etaxonomy.cdm.model.reference.Reference, java.lang.String)
+     */
+    @Override
+    public DescriptionElementSource addImportSource(String id, String idNamespace, Reference<?> citation, String microCitation) {
+        if (id == null && idNamespace == null && citation == null && microCitation == null){
+            return null;
+        }
+        DescriptionElementSource source = DescriptionElementSource.NewInstance(OriginalSourceType.Import, id, idNamespace, citation, microCitation);
         addSource(source);
         return source;
     }
 
-    public void addSource(String id, String idNamespace, Reference citation, String microReference, TaxonNameBase nameUsedInSource, String originalNameString){
-        DescriptionElementSource newSource = DescriptionElementSource.NewInstance(id, idNamespace, citation, microReference, nameUsedInSource, originalNameString);
+    /**
+     * Adds a {@link IOriginalSource source} to this description element.
+     * @param type the type of the source
+     * @param idInSource the id used in the source 
+     * @param idNamespace the namespace for the id in the source
+     * @param citation the source as a {@link Reference reference}
+     * @param microReference the details (e.g. page number) in the reference
+     * @param nameUsedInSource the taxon name used in the source
+     * @param originalNameString the name as text used in the source
+     */
+    public void addSource(OriginalSourceType type, String idInSource, String idNamespace, Reference citation, String microReference, TaxonNameBase nameUsedInSource, String originalNameString){
+        DescriptionElementSource newSource = DescriptionElementSource.NewInstance(type, idInSource, idNamespace, citation, microReference, nameUsedInSource, originalNameString);
         addSource(newSource);
     }
 
@@ -401,22 +449,22 @@ public abstract class DescriptionElementBase extends AnnotatableEntity implement
 
 // ******************* METHODS *************************************************************/
 
-    protected Map<TermVocabulary, List<Modifier>> makeModifierMap(){
-        Map<TermVocabulary, List<Modifier>> result = new HashMap<TermVocabulary, List<Modifier>>();
-        for (Modifier modifier : getModifiers()){
-            TermVocabulary<Modifier> voc = modifier.getVocabulary();
+    protected Map<TermVocabulary, List<DefinedTerm>> makeModifierMap(){
+        Map<TermVocabulary, List<DefinedTerm>> result = new HashMap<TermVocabulary, List<DefinedTerm>>();
+        for (DefinedTerm modifier : getModifiers()){
+            TermVocabulary<DefinedTerm> voc = modifier.getVocabulary();
             if (result.get(voc) == null){
-                result.put(voc, new ArrayList<Modifier>());
+                result.put(voc, new ArrayList<DefinedTerm>());
             }
             result.get(voc).add(modifier);
         }
         return result;
     }
 
-    public List<Modifier> getModifiers(TermVocabulary voc){
-        List<Modifier> result = makeModifierMap().get(voc);
+    public List<DefinedTerm> getModifiers(TermVocabulary voc){
+        List<DefinedTerm> result = makeModifierMap().get(voc);
         if (result == null){
-            result = new ArrayList<Modifier>();
+            result = new ArrayList<DefinedTerm>();
         }
         return result;
     }
@@ -459,8 +507,8 @@ public abstract class DescriptionElementBase extends AnnotatableEntity implement
         }
 
         //modifiers
-        result.modifiers = new HashSet<Modifier>();
-        for (Modifier modifier : getModifiers()){
+        result.modifiers = new HashSet<DefinedTerm>();
+        for (DefinedTerm modifier : getModifiers()){
             result.modifiers.add(modifier);
         }
 
